Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.1.1.3.4.2.2.3
retrieving revision 1.1.1.3.4.2.2.3.2.1
diff -u -r1.1.1.3.4.2.2.3 -r1.1.1.3.4.2.2.3.2.1
--- squid/src/structs.h	14 Jun 2001 20:36:16 -0000	1.1.1.3.4.2.2.3
+++ squid/src/structs.h	27 Aug 2001 21:48:22 -0000	1.1.1.3.4.2.2.3.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: structs.h,v 1.1.1.3.4.2.2.3 2001/06/14 20:36:16 serassio Exp $
+ * $Id: structs.h,v 1.1.1.3.4.2.2.3.2.1 2001/08/27 21:48:22 tolsty Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -31,43 +30,50 @@
  *
  */
 
-struct _dlink_node {
+struct _dlink_node
+{
     void *data;
     dlink_node *prev;
     dlink_node *next;
 };
 
-struct _dlink_list {
+struct _dlink_list
+{
     dlink_node *head;
     dlink_node *tail;
 };
 
-struct _acl_ip_data {
+struct _acl_ip_data
+{
     struct in_addr addr1;	/* if addr2 non-zero then its a range */
     struct in_addr addr2;
     struct in_addr mask;
     acl_ip_data *next;		/* used for parsing, not for storing */
 };
 
-struct _acl_snmp_comm {
+struct _acl_snmp_comm
+{
     char *name;
     void *community;
     acl_snmp_comm *next;
 };
 
-struct _acl_time_data {
+struct _acl_time_data
+{
     int weekbits;
     int start;
     int stop;
     acl_time_data *next;
 };
 
-struct _acl_name_list {
+struct _acl_name_list
+{
     char name[ACL_NAME_SZ];
     acl_name_list *next;
 };
 
-struct _acl_proxy_auth_user {
+struct _acl_proxy_auth_user
+{
     /* first two items must be same as hash_link */
     char *user;
     acl_proxy_auth_user *next;
@@ -79,7 +85,8 @@
     time_t ip_expiretime;
 };
 
-struct _acl_deny_info_list {
+struct _acl_deny_info_list
+{
     int err_page_id;
     char *err_page_name;
     acl_name_list *acl_list;
@@ -88,13 +95,15 @@
 
 #if USE_ARP_ACL
 
-struct _acl_arp_data {
+struct _acl_arp_data
+{
     char eth[6];
 };
 
 #endif
 
-struct _String {
+struct _String
+{
     /* never reference these directly! */
     unsigned short int size;	/* buffer size; 64K limit */
     unsigned short int len;	/* current length  */
@@ -103,7 +112,8 @@
 
 #if SQUID_SNMP
 
-struct _snmp_request_t {
+struct _snmp_request_t
+{
     u_char *buf;
     u_char *outbuf;
     int len;
@@ -118,7 +128,8 @@
 
 #endif
 
-struct _acl {
+struct _acl
+{
     char name[ACL_NAME_SZ];
     squid_acl type;
     void *data;
@@ -126,20 +137,23 @@
     acl *next;
 };
 
-struct _acl_list {
+struct _acl_list
+{
     int op;
     acl *acl;
     acl_list *next;
 };
 
-struct _acl_access {
+struct _acl_access
+{
     int allow;
     acl_list *acl_list;
     char *cfgline;
     acl_access *next;
 };
 
-struct _aclCheck_t {
+struct _aclCheck_t
+{
     const acl_access *access_list;
     struct in_addr src_addr;
     struct in_addr dst_addr;
@@ -159,45 +173,53 @@
     void *callback_data;
 };
 
-struct _aio_result_t {
+struct _aio_result_t
+{
     int aio_return;
     int aio_errno;
 };
 
-struct _wordlist {
+struct _wordlist
+{
     char *key;
     wordlist *next;
 };
 
-struct _intlist {
+struct _intlist
+{
     int i;
     intlist *next;
 };
 
-struct _intrange {
+struct _intrange
+{
     int i;
     int j;
     intrange *next;
 };
 
-struct _ushortlist {
+struct _ushortlist
+{
     u_short i;
     ushortlist *next;
 };
 
-struct _relist {
+struct _relist
+{
     char *pattern;
     regex_t regex;
     relist *next;
 };
 
-struct _sockaddr_in_list {
+struct _sockaddr_in_list
+{
     struct sockaddr_in s;
     sockaddr_in_list *next;
 };
 
 #if DELAY_POOLS
-struct _delaySpec {
+struct _delaySpec
+{
     int restore_bps;
     int max_bytes;
 };
@@ -205,13 +227,15 @@
 /* malloc()'d only as far as used (class * sizeof(delaySpec)!
  * order of elements very important!
  */
-struct _delaySpecSet {
+struct _delaySpecSet
+{
     delaySpec aggregate;
     delaySpec individual;
     delaySpec network;
 };
 
-struct _delayConfig {
+struct _delayConfig
+{
     unsigned short pools;
     unsigned short initial;
     unsigned char *class;
@@ -221,23 +245,30 @@
 
 #endif
 
-struct _SquidConfig {
-    struct {
+struct _SquidConfig
+{
+    struct
+    {
 	size_t maxSize;
 	int highWaterMark;
 	int lowWaterMark;
-    } Swap;
+    }
+    Swap;
     size_t memMaxSize;
-    struct {
+    struct
+    {
 	char *relayHost;
 	u_short relayPort;
 	peer *peer;
-    } Wais;
-    struct {
+    }
+    Wais;
+    struct
+    {
 	size_t min;
 	int pct;
 	size_t max;
-    } quickAbort;
+    }
+    quickAbort;
 #if HEAP_REPLACEMENT
     char *replPolicy;
 #else
@@ -251,7 +282,8 @@
     time_t negativeDnsTtl;
     time_t positiveDnsTtl;
     time_t shutdownLifetime;
-    struct {
+    struct
+    {
 	time_t read;
 	time_t lifetime;
 	time_t connect;
@@ -266,11 +298,13 @@
 #if USE_IDENT
 	time_t ident;
 #endif
-    } Timeout;
+    }
+    Timeout;
     size_t maxRequestHeaderSize;
     size_t maxRequestBodySize;
     size_t maxReplyBodySize;
-    struct {
+    struct
+    {
 	u_short icp;
 #if USE_HTCP
 	u_short htcp;
@@ -278,37 +312,47 @@
 #if SQUID_SNMP
 	u_short snmp;
 #endif
-    } Port;
-    struct {
+    }
+    Port;
+    struct
+    {
 	sockaddr_in_list *http;
-    } Sockaddr;
+    }
+    Sockaddr;
 #if SQUID_SNMP
-    struct {
+    struct
+    {
 	char *configFile;
 	char *agentInfo;
-    } Snmp;
+    }
+    Snmp;
 #endif
 #if USE_WCCP
-    struct {
+    struct
+    {
 	struct in_addr router;
 	struct in_addr incoming;
 	struct in_addr outgoing;
 	int version;
-    } Wccp;
+    }
+    Wccp;
 #endif
     char *as_whois_server;
-    struct {
+    struct
+    {
 	char *log;
 	char *access;
 	char *store;
 	char *swap;
 	char *useragent;
 	int rotateNumber;
-    } Log;
+    }
+    Log;
     char *adminEmail;
     char *effectiveUser;
     char *effectiveGroup;
-    struct {
+    struct
+    {
 #if USE_DNSSERVERS
 	char *dnsserver;
 #endif
@@ -316,7 +360,8 @@
 	wordlist *authenticate;
 	char *pinger;
 	char *unlinkd;
-    } Program;
+    }
+    Program;
 #if USE_DNSSERVERS
     int dnsChildren;
 #endif
@@ -324,10 +369,12 @@
     int authenticateChildren;
     int authenticateTTL;
     int authenticateIpTTL;
-    struct {
+    struct
+    {
 	char *host;
 	u_short port;
-    } Accel;
+    }
+    Accel;
     char *appendDomain;
     size_t appendDomainLen;
     char *debugOptions;
@@ -337,13 +384,16 @@
     char *uniqueHostname;
     wordlist *hostnameAliases;
     char *errHtmlText;
-    struct {
+    struct
+    {
 	char *host;
 	char *file;
 	time_t period;
 	u_short port;
-    } Announce;
-    struct {
+    }
+    Announce;
+    struct
+    {
 	struct in_addr tcp_outgoing;
 	struct in_addr udp_incoming;
 	struct in_addr udp_outgoing;
@@ -352,7 +402,8 @@
 	struct in_addr snmp_outgoing;
 #endif
 	struct in_addr client_netmask;
-    } Addrs;
+    }
+    Addrs;
     size_t tcpRcvBufsz;
     size_t udpMaxHitObjsz;
     wordlist *hierarchy_stoplist;
@@ -361,28 +412,37 @@
     wordlist *dns_nameservers;
     peer *peers;
     int npeers;
-    struct {
+    struct
+    {
 	int size;
 	int low;
 	int high;
-    } ipcache;
-    struct {
+    }
+    ipcache;
+    struct
+    {
 	int size;
-    } fqdncache;
+    }
+    fqdncache;
     int minDirectHops;
     cachemgr_passwd *passwd_list;
-    struct {
+    struct
+    {
 	int objectsPerBucket;
 	size_t avgObjectSize;
 	size_t maxObjectSize;
 	size_t minObjectSize;
-    } Store;
-    struct {
+    }
+    Store;
+    struct
+    {
 	int high;
 	int low;
 	time_t period;
-    } Netdb;
-    struct {
+    }
+    Netdb;
+    struct
+    {
 	int log_udp;
 #if USE_DNSSERVERS
 	int res_defnames;
@@ -417,10 +477,13 @@
 #if USE_CACHE_DIGESTS
 	int digest_generation;
 #endif
+	int log_redirected_url;
 	int ie_refresh;
-    } onoff;
+    }
+    onoff;
     acl *aclList;
-    struct {
+    struct
+    {
 	acl_access *http;
 	acl_access *icp;
 	acl_access *miss;
@@ -436,88 +499,112 @@
 	acl_access *identLookup;
 #endif
 	acl_access *redirector;
-    } accessList;
+    }
+    accessList;
     acl_deny_info_list *denyInfoList;
     char *proxyAuthRealm;
-    struct {
+    struct
+    {
 	size_t list_width;
 	int list_wrap;
 	char *anon_user;
 	int passive;
-    } Ftp;
+    }
+    Ftp;
     refresh_t *Refresh;
-    struct _cacheSwap {
+    struct _cacheSwap
+    {
 	SwapDir *swapDirs;
 	int n_allocated;
 	int n_configured;
-    } cacheSwap;
+    }
+    cacheSwap;
     char *fake_ua;
-    struct {
+    struct
+    {
 	char *directory;
-    } icons;
+    }
+    icons;
     char *errorDirectory;
-    struct {
+    struct
+    {
 	time_t timeout;
 	int maxtries;
-    } retry;
-    struct {
+    }
+    retry;
+    struct
+    {
 	size_t limit;
-    } MemPools;
+    }
+    MemPools;
 #if DELAY_POOLS
     delayConfig Delay;
 #endif
-    struct {
+    struct
+    {
 	int icp_average;
 	int dns_average;
 	int http_average;
 	int icp_min_poll;
 	int dns_min_poll;
 	int http_min_poll;
-    } comm_incoming;
+    }
+    comm_incoming;
     int max_open_disk_fds;
     int uri_whitespace;
     size_t rangeOffsetLimit;
 #if MULTICAST_MISS_STREAM
-    struct {
+    struct
+    {
 	struct in_addr addr;
 	int ttl;
 	unsigned short port;
 	char *encode_key;
-    } mcast_miss;
+    }
+    mcast_miss;
 #endif
     HttpHeaderMask anonymize_headers;
     char *coredump_dir;
     char *chroot_dir;
 #if USE_CACHE_DIGESTS
-    struct {
+    struct
+    {
 	int bits_per_entry;
 	time_t rebuild_period;
 	time_t rewrite_period;
 	size_t swapout_chunk_size;
 	int rebuild_chunk_percentage;
-    } digest;
+    }
+    digest;
 #endif
 };
 
-struct _SquidConfig2 {
-    struct {
+struct _SquidConfig2
+{
+    struct
+    {
 	char *prefix;
 	int on;
-    } Accel;
-    struct {
+    }
+    Accel;
+    struct
+    {
 	int enable_purge;
-    } onoff;
+    }
+    onoff;
     uid_t effectiveUserID;
     gid_t effectiveGroupID;
 };
 
-struct _close_handler {
+struct _close_handler
+{
     PF *handler;
     void *data;
     close_handler *next;
 };
 
-struct _dread_ctrl {
+struct _dread_ctrl
+{
     int fd;
     off_t offset;
     int req_len;
@@ -527,7 +614,8 @@
     void *client_data;
 };
 
-struct _dnsserver_t {
+struct _dnsserver_t
+{
     int id;
     int inpipe;
     int outpipe;
@@ -539,13 +627,15 @@
     void *data;
 };
 
-struct _dnsStatData {
+struct _dnsStatData
+{
     int requests;
     int replies;
     int hist[DefaultDnsChildrenMax];
 };
 
-struct _dwrite_q {
+struct _dwrite_q
+{
     off_t file_offset;
     char *buf;
     int len;
@@ -559,18 +649,21 @@
  * this struct is likely to change
  * Note: "str" points to memory in HttpHeaderEntry (for now)
  *       so ETags should be used as tmp variables only (for now) */
-struct _ETag {
+struct _ETag
+{
     const char *str;		/* quoted-string */
     int weak;			/* true if it is a weak validator */
 };
 #ifdef _SQUID_MSWIN_
-struct _sde {
+struct _sde
+{
     unsigned int type;
     u_short local_port;
     u_short remote_port;
     char ipaddr[16];		/* dotted decimal address of peer */
     char desc[FD_DESC_SZ];
-    struct {
+    struct
+    {
 	unsigned int open:1;
 	unsigned int close_request:1;
 	unsigned int write_daemon:1;
@@ -583,7 +676,8 @@
 #ifdef OPTIMISTIC_IO
 	unsigned int calling_io_handler:1;
 #endif
-    } flags;
+    }
+    flags;
     int bytes_read;
     int bytes_written;
     int uses;			/* ie # req's over persistent conn */
@@ -601,31 +695,34 @@
     CommWriteStateData *rwstate;	/* State data for comm_write */
 };
 
-struct statfs {
-   long    f_type;     /* type of filesystem (see below) */
-   long    f_bsize;    /* optimal transfer block size */
-   long    f_blocks;   /* total data blocks in file system */
-   long    f_bfree;    /* free blocks in fs */
-   long    f_bavail;   /* free blocks avail to non-superuser */
-   long    f_files;    /* total file nodes in file system */
-   long    f_ffree;    /* free file nodes in fs */
-   long    f_fsid;     /* file system id */
-   long    f_namelen;  /* maximum length of filenames */
-   long    f_spare[6]; /* spare for later */
+struct statfs
+{
+    long f_type;		/* type of filesystem (see below) */
+    long f_bsize;		/* optimal transfer block size */
+    long f_blocks;		/* total data blocks in file system */
+    long f_bfree;		/* free blocks in fs */
+    long f_bavail;		/* free blocks avail to non-superuser */
+    long f_files;		/* total file nodes in file system */
+    long f_ffree;		/* free file nodes in fs */
+    long f_fsid;		/* file system id */
+    long f_namelen;		/* maximum length of filenames */
+    long f_spare[6];		/* spare for later */
 };
 #endif
 
 
-struct _fde {
+struct _fde
+{
     unsigned int type;
     u_short local_port;
     u_short remote_port;
 #ifdef _SQUID_MSWIN_
-	FILE * fbuf;
+    FILE *fbuf;
 #endif
     char ipaddr[16];		/* dotted decimal address of peer */
     char desc[FD_DESC_SZ];
-    struct {
+    struct
+    {
 	unsigned int open:1;
 	unsigned int close_request:1;
 	unsigned int write_daemon:1;
@@ -635,17 +732,20 @@
 	unsigned int nonblocking:1;
 	unsigned int ipc:1;
 	unsigned int called_connect:1;
-    } flags;
+    }
+    flags;
     int bytes_read;
     int bytes_written;
     int uses;			/* ie # req's over persistent conn */
-    struct _fde_disk {
+    struct _fde_disk
+    {
 	DWCB *wrt_handle;
 	void *wrt_handle_data;
 	dwrite_q *write_q;
 	dwrite_q *write_q_tail;
 	off_t offset;
-    } disk;
+    }
+    disk;
     PF *read_handler;
     void *read_data;
     PF *write_handler;
@@ -660,7 +760,8 @@
     CommWriteStateData *rwstate;	/* State data for comm_write */
 };
 
-struct _fileMap {
+struct _fileMap
+{
     int max_n_files;
     int n_files_in_map;
     int toggle;
@@ -670,7 +771,8 @@
 
 /* auto-growing memory-resident buffer with printf interface */
 /* note: when updating this struct, update MemBufNULL #define */
-struct _MemBuf {
+struct _MemBuf
+{
     /* public, read-only */
     char *buf;
     mb_size_t size;		/* used space, does not count 0-terminator */
@@ -682,7 +784,8 @@
 };
 
 /* see Packer.c for description */
-struct _Packer {
+struct _Packer
+{
     /* protected, use interface functions instead */
     append_f append;
     vprintf_f vprintf;
@@ -690,7 +793,8 @@
 };
 
 /* http status line */
-struct _HttpStatusLine {
+struct _HttpStatusLine
+{
     /* public, read only */
     float version;
     const char *reason;		/* points to a _constant_ string (default or supplied), never free()d */
@@ -701,26 +805,30 @@
  * Note: HttpBody is used only for messages with a small content that is
  * known a priory (e.g., error messages).
  */
-struct _HttpBody {
+struct _HttpBody
+{
     /* private */
     MemBuf mb;
 };
 
 /* http header extention field */
-struct _HttpHdrExtField {
+struct _HttpHdrExtField
+{
     String name;		/* field-name  from HTTP/1.1 (no column after name) */
     String value;		/* field-value from HTTP/1.1 */
 };
 
 /* http cache control header field */
-struct _HttpHdrCc {
+struct _HttpHdrCc
+{
     int mask;
     int max_age;
     int s_maxage;
 };
 
 /* http byte-range-spec */
-struct _HttpHdrRangeSpec {
+struct _HttpHdrRangeSpec
+{
     ssize_t offset;
     ssize_t length;
 };
@@ -729,25 +837,29 @@
  * This object holds all range specs in order of their appearence
  * in the request because we SHOULD preserve that order.
  */
-struct _HttpHdrRange {
+struct _HttpHdrRange
+{
     Stack specs;
 };
 
 /* http content-range header field */
-struct _HttpHdrContRange {
+struct _HttpHdrContRange
+{
     HttpHdrRangeSpec spec;
     ssize_t elength;		/* entity length, not content length */
 };
 
 /* some fields can hold either time or etag specs (e.g. If-Range) */
-struct _TimeOrTag {
+struct _TimeOrTag
+{
     ETag tag;			/* entity tag */
     time_t time;
     int valid;			/* true if struct is usable */
 };
 
 /* data for iterating thru range specs */
-struct _HttpHdrRangeIter {
+struct _HttpHdrRangeIter
+{
     HttpHdrRangePos pos;
     const HttpHdrRangeSpec *spec;	/* current spec at pos */
     ssize_t debt_size;		/* bytes left to send from the current spec */
@@ -756,14 +868,16 @@
 };
 
 /* constant attributes of http header fields */
-struct _HttpHeaderFieldAttrs {
+struct _HttpHeaderFieldAttrs
+{
     const char *name;
     http_hdr_type id;
     field_type type;
 };
 
 /* per field statistics */
-struct _HttpHeaderFieldStat {
+struct _HttpHeaderFieldStat
+{
     int aliveCount;		/* created but not destroyed (count) */
     int seenCount;		/* #fields we've seen */
     int parsCount;		/* #parsing attempts */
@@ -772,20 +886,23 @@
 };
 
 /* compiled version of HttpHeaderFieldAttrs plus stats */
-struct _HttpHeaderFieldInfo {
+struct _HttpHeaderFieldInfo
+{
     http_hdr_type id;
     String name;
     field_type type;
     HttpHeaderFieldStat stat;
 };
 
-struct _HttpHeaderEntry {
+struct _HttpHeaderEntry
+{
     http_hdr_type id;
     String name;
     String value;
 };
 
-struct _HttpHeader {
+struct _HttpHeader
+{
     /* protected, do not use these, use interface functions instead */
     Array entries;		/* parsed fields in raw format */
     HttpHeaderMask mask;	/* bit set <=> entry present */
@@ -793,7 +910,8 @@
     int len;			/* length when packed, not counting terminating '\0' */
 };
 
-struct _HttpReply {
+struct _HttpReply
+{
     /* unsupported, writable, may disappear/change in the future */
     int hdr_sz;			/* sums _stored_ status-line, headers, and <CRLF> */
 
@@ -816,13 +934,15 @@
     HttpBody body;		/* for small constant memory-resident text bodies only */
 };
 
-struct _http_state_flags {
+struct _http_state_flags
+{
     unsigned int proxying:1;
     unsigned int keepalive:1;
     unsigned int only_if_cached:1;
 };
 
-struct _HttpStateData {
+struct _HttpStateData
+{
     StoreEntry *entry;
     request_t *request;
     char *reply_hdr;
@@ -835,7 +955,8 @@
     FwdState *fwd;
 };
 
-struct _icpUdpData {
+struct _icpUdpData
+{
     struct sockaddr_in address;
     void *msg;
     size_t len;
@@ -847,7 +968,8 @@
     struct timeval queue_time;
 };
 
-struct _ping_data {
+struct _ping_data
+{
     struct timeval start;
     struct timeval stop;
     int n_sent;
@@ -859,7 +981,8 @@
     int p_rtt;
 };
 
-struct _HierarchyLogEntry {
+struct _HierarchyLogEntry
+{
     hier_code code;
     char host[SQUIDHOSTNAMELEN];
     ping_data ping;
@@ -872,43 +995,57 @@
     struct timeval store_complete_stop;
 };
 
-struct _AccessLogEntry {
+struct _AccessLogEntry
+{
     const char *url;
-    struct {
+    struct
+    {
 	method_t method;
 	int code;
 	const char *content_type;
 	float version;
-    } http;
-    struct {
+    }
+    http;
+    struct
+    {
 	icp_opcode opcode;
-    } icp;
-    struct {
+    }
+    icp;
+    struct
+    {
 	struct in_addr caddr;
 	size_t size;
 	log_type code;
 	int msec;
 	const char *ident;
-    } cache;
-    struct {
+    }
+    cache;
+    struct
+    {
 	char *request;
 	char *reply;
-    } headers;
-    struct {
+    }
+    headers;
+    struct
+    {
 	const char *method_str;
-    } private;
+    }
+    private;
     HierarchyLogEntry hier;
 };
 
-struct _clientHttpRequest {
+struct _clientHttpRequest
+{
     ConnStateData *conn;
     request_t *request;		/* Parsed URL ... */
     char *uri;
     char *log_uri;
-    struct {
+    struct
+    {
 	off_t offset;
 	size_t size;
-    } out;
+    }
+    out;
     HttpHdrRangeIter range_iter;	/* data for iterating thru range specs */
     size_t req_sz;		/* raw request size on input, not current request size */
     StoreEntry *entry;
@@ -924,25 +1061,32 @@
     aclCheck_t *acl_checklist;	/* need ptr back so we can unreg if needed */
     clientHttpRequest *next;
     AccessLogEntry al;
-    struct {
+    struct
+    {
 	unsigned int accel:1;
 	unsigned int internal:1;
 	unsigned int done_copying:1;
-    } flags;
-    struct {
+    }
+    flags;
+    struct
+    {
 	http_status status;
 	char *location;
-    } redirect;
+    }
+    redirect;
     dlink_node active;
 };
 
-struct _ConnStateData {
+struct _ConnStateData
+{
     int fd;
-    struct {
+    struct
+    {
 	char *buf;
 	off_t offset;
 	size_t size;
-    } in;
+    }
+    in;
     clientHttpRequest *chr;
     struct sockaddr_in peer;
     struct sockaddr_in me;
@@ -950,13 +1094,16 @@
     char ident[USER_IDENT_SZ];
     int nrequests;
     int persistent;
-    struct {
+    struct
+    {
 	int n;
 	time_t until;
-    } defer;
+    }
+    defer;
 };
 
-struct _ipcache_addrs {
+struct _ipcache_addrs
+{
     struct in_addr *in_addrs;
     unsigned char *bad_mask;
     unsigned char count;
@@ -964,13 +1111,15 @@
     unsigned char badcount;
 };
 
-struct _ip_pending {
+struct _ip_pending
+{
     IPH *handler;
     void *handlerData;
     ip_pending *next;
 };
 
-struct _ipcache_entry {
+struct _ipcache_entry
+{
     /* first two items must be equivalent to hash_link */
     char *name;
     ipcache_entry *next;
@@ -985,13 +1134,15 @@
     ipcache_status_t status:3;
 };
 
-struct _fqdn_pending {
+struct _fqdn_pending
+{
     FQDNH *handler;
     void *handlerData;
     fqdn_pending *next;
 };
 
-struct _fqdncache_entry {
+struct _fqdncache_entry
+{
     /* first two items must be equivalent to hash_link */
     char *name;
     fqdncache_entry *next;
@@ -1007,26 +1158,30 @@
     fqdncache_status_t status:3;
 };
 
-struct _domain_ping {
+struct _domain_ping
+{
     char *domain;
     int do_ping;		/* boolean */
     domain_ping *next;
 };
 
-struct _domain_type {
+struct _domain_type
+{
     char *domain;
     peer_t type;
     domain_type *next;
 };
 
 #if USE_CACHE_DIGESTS
-struct _Version {
+struct _Version
+{
     short int current;		/* current version */
     short int required;		/* minimal version that can safely handle current version */
 };
 
 /* digest control block; used for transmission and storage */
-struct _StoreDigestCBlock {
+struct _StoreDigestCBlock
+{
     Version ver;
     int capacity;
     int count;
@@ -1038,7 +1193,8 @@
     int reserved[32 - 6];
 };
 
-struct _DigestFetchState {
+struct _DigestFetchState
+{
     PeerDigest *pd;
     StoreEntry *entry;
     StoreEntry *old_entry;
@@ -1048,14 +1204,17 @@
     time_t start_time;
     time_t resp_time;
     time_t expires;
-    struct {
+    struct
+    {
 	int msg;
 	int bytes;
-    } sent, recv;
+    }
+    sent  , recv;
 };
 
 /* statistics for cache digests and other hit "predictors" */
-struct _cd_guess_stats {
+struct _cd_guess_stats
+{
     /* public, read-only */
     int true_hits;
     int false_hits;
@@ -1064,17 +1223,21 @@
     int close_hits;		/* tmp, remove it later */
 };
 
-struct _PeerDigest {
+struct _PeerDigest
+{
     peer *peer;			/* pointer back to peer structure, argh */
     CacheDigest *cd;		/* actual digest structure */
     String host;		/* copy of peer->host */
     const char *req_result;	/* text status of the last request */
-    struct {
+    struct
+    {
 	unsigned int needed:1;	/* there were requests for this digest */
 	unsigned int usable:1;	/* can be used for lookups */
 	unsigned int requested:1;	/* in process of receiving [fresh] digest */
-    } flags;
-    struct {
+    }
+    flags;
+    struct
+    {
 	/* all times are absolute unless augmented with _delay */
 	time_t initialized;	/* creation */
 	time_t needed;		/* first lookup/use by a peer */
@@ -1084,24 +1247,31 @@
 	time_t req_delay;	/* last request response time */
 	time_t received;	/* received the current copy of a digest */
 	time_t disabled;	/* disabled for good */
-    } times;
-    struct {
+    }
+    times;
+    struct
+    {
 	cd_guess_stats guess;
 	int used_count;
-	struct {
+	struct
+	{
 	    int msgs;
 	    kb_t kbytes;
-	} sent, recv;
-    } stats;
+	}
+	sent  , recv;
+    }
+    stats;
 };
 
 #endif
 
-struct _peer {
+struct _peer
+{
     char *host;
     peer_t type;
     struct sockaddr_in in_addr;
-    struct {
+    struct
+    {
 	int pings_sent;
 	int pings_acked;
 	int fetches;
@@ -1112,24 +1282,30 @@
 	time_t last_query;
 	time_t last_reply;
 	int logged_state;	/* so we can print dead/revived msgs */
-    } stats;
-    struct {
+    }
+    stats;
+    struct
+    {
 	int version;
 	int counts[ICP_END];
 	u_short port;
-    } icp;
+    }
+    icp;
 #if USE_HTCP
-    struct {
+    struct
+    {
 	double version;
 	int counts[2];
 	u_short port;
-    } htcp;
+    }
+    htcp;
 #endif
     u_short http_port;
     domain_ping *peer_domain;
     domain_type *typelist;
     acl_access *access;
-    struct {
+    struct
+    {
 	unsigned int proxy_only:1;
 	unsigned int no_query:1;
 	unsigned int no_digest:1;
@@ -1144,19 +1320,24 @@
 #if DELAY_POOLS
 	unsigned int no_delay:1;
 #endif
-    } options;
+    }
+    options;
     int weight;
-    struct {
+    struct
+    {
 	double avg_n_members;
 	int n_times_counted;
 	int n_replies_expected;
 	int ttl;
 	int id;
-	struct {
+	struct
+	{
 	    unsigned int count_event_pending:1;
 	    unsigned int counting:1;
-	} flags;
-    } mcast;
+	}
+	flags;
+    }
+    mcast;
 #if USE_CACHE_DIGESTS
     PeerDigest *digest;
     char *digest_url;
@@ -1169,31 +1350,36 @@
     peer *next;
     int test_fd;
 #if USE_CARP
-    struct {
+    struct
+    {
 	unsigned long hash;
 	unsigned long load_multiplier;
 	float load_factor;
-    } carp;
+    }
+    carp;
 #endif
     char *login;		/* Proxy authorization */
     time_t connect_timeout;
 };
 
-struct _net_db_name {
+struct _net_db_name
+{
     char *name;
     net_db_name *htbl_next;
     net_db_name *next;
     netdbEntry *net_db_entry;
 };
 
-struct _net_db_peer {
+struct _net_db_peer
+{
     char *peername;
     double hops;
     double rtt;
     time_t expires;
 };
 
-struct _netdbEntry {
+struct _netdbEntry
+{
     /* first two items must be equivalent to hash_link */
     char *key;
     netdbEntry *next;
@@ -1211,7 +1397,8 @@
     int n_peers;
 };
 
-struct _ps_state {
+struct _ps_state
+{
     request_t *request;
     StoreEntry *entry;
     int always_direct;
@@ -1242,14 +1429,16 @@
     aclCheck_t *acl_checklist;
 };
 
-struct _pingerEchoData {
+struct _pingerEchoData
+{
     struct in_addr to;
     unsigned char opcode;
     int psize;
     char payload[PINGER_PAYLOAD_SZ];
 };
 
-struct _pingerReplyData {
+struct _pingerReplyData
+{
     struct in_addr from;
     unsigned char opcode;
     int rtt;
@@ -1258,7 +1447,8 @@
     char payload[PINGER_PAYLOAD_SZ];
 };
 
-struct _icp_common_t {
+struct _icp_common_t
+{
     unsigned char opcode;	/* opcode */
     unsigned char version;	/* version number */
     unsigned short length;	/* total length (bytes) */
@@ -1268,30 +1458,36 @@
     u_num32 shostid;		/* sender host id */
 };
 
-struct _iostats {
-    struct {
+struct _iostats
+{
+    struct
+    {
 	int reads;
 	int reads_deferred;
 	int read_hist[16];
 	int writes;
 	int write_hist[16];
-    } Http, Ftp, Gopher, Wais;
+    }
+    Http  , Ftp, Gopher, Wais;
 };
 
-struct _mem_node {
+struct _mem_node
+{
     char *data;
     int len;
     mem_node *next;
 };
 
-struct _mem_hdr {
+struct _mem_hdr
+{
     mem_node *head;
     mem_node *tail;
     int origin_offset;
 };
 
 /* keep track each client receiving data from that particular StoreEntry */
-struct _store_client {
+struct _store_client
+{
     int type;
     off_t copy_offset;
     off_t seen_offset;
@@ -1301,11 +1497,13 @@
     void *callback_data;
     StoreEntry *entry;		/* ptr to the parent StoreEntry, argh! */
     storeIOState *swapin_sio;
-    struct {
+    struct
+    {
 	unsigned int disk_io_pending:1;
 	unsigned int store_copying:1;
 	unsigned int copy_event_pending:1;
-    } flags;
+    }
+    flags;
     store_client *next;
 #if DELAY_POOLS
     delay_id delay_id;
@@ -1314,7 +1512,8 @@
 
 
 /* This structure can be freed while object is purged out from memory */
-struct _MemObject {
+struct _MemObject
+{
     method_t method;
     char *url;
     mem_hdr data_hdr;
@@ -1322,20 +1521,24 @@
     off_t inmem_lo;
     store_client *clients;
     int nclients;
-    struct {
+    struct
+    {
 	off_t queue_offset;	/* relative to in-mem data */
 	storeIOState *sio;
-    } swapout;
+    }
+    swapout;
     HttpReply *reply;
     request_t *request;
     struct timeval start_ping;
     IRCB *ping_reply_callback;
     void *ircb_data;
     int fd;			/* FD of client creating this entry */
-    struct {
+    struct
+    {
 	STABH *callback;
 	void *data;
-    } abort;
+    }
+    abort;
     char *log_url;
 #if HEAP_REPLACEMENT
     /* 
@@ -1350,7 +1553,8 @@
     size_t swap_hdr_sz;
 };
 
-struct _StoreEntry {
+struct _StoreEntry
+{
     /* first two items must be same as hash_link */
     const cache_key *key;
     StoreEntry *next;
@@ -1375,7 +1579,8 @@
     swap_status_t swap_status:3;
 };
 
-struct _SwapDir {
+struct _SwapDir
+{
     swapdir_t type;
     fileMap *map;
     int cur_size;
@@ -1383,42 +1588,57 @@
     char *path;
     int index;			/* This entry's index into the swapDirs array */
     int suggest;
-    struct {
+    struct
+    {
 	unsigned int selected:1;
 	unsigned int read_only:1;
-    } flags;
+    }
+    flags;
     STINIT *init;
     STNEWFS *newfs;
-    struct {
+    struct
+    {
 	STOBJOPEN *open;
 	STOBJCLOSE *close;
 	STOBJREAD *read;
 	STOBJWRITE *write;
 	STOBJUNLINK *unlink;
-    } obj;
-    struct {
+    }
+    obj;
+    struct
+    {
 	STLOGOPEN *open;
 	STLOGCLOSE *close;
 	STLOGWRITE *write;
-	struct {
+	struct
+	{
 	    STLOGCLEANOPEN *open;
 	    STLOGCLEANWRITE *write;
 	    void *state;
-	} clean;
-    } log;
-    struct {
+	}
+	clean;
+    }
+    log;
+    struct
+    {
 	int blksize;
-    } fs;
-    union {
-	struct {
+    }
+    fs;
+    union
+    {
+	struct
+	{
 	    int l1;
 	    int l2;
 	    int swaplog_fd;
-	} ufs;
-    } u;
+	}
+	ufs;
+    }
+    u;
 };
 
-struct _request_flags {
+struct _request_flags
+{
     unsigned int range:1;
     unsigned int nocache:1;
     unsigned int ims:1;
@@ -1439,50 +1659,67 @@
     unsigned int internal:1;
 };
 
-struct _link_list {
+struct _link_list
+{
     void *ptr;
     struct _link_list *next;
 };
 
-struct _storeIOState {
+struct _storeIOState
+{
     sfileno swap_file_number;
     mode_t mode;
     size_t st_size;		/* do stat(2) after read open */
     off_t offset;		/* current offset pointer */
     STIOCB *callback;
     void *callback_data;
-    struct {
+    struct
+    {
 	STRCB *callback;
 	void *callback_data;
-    } read;
-    struct {
+    }
+    read;
+    struct
+    {
 	unsigned int closing:1;	/* debugging aid */
-    } flags;
-    union {
-	struct {
+    }
+    flags;
+    union
+    {
+	struct
+	{
 	    int fd;
-	    struct {
+	    struct
+	    {
 		unsigned int close_request:1;
 		unsigned int reading:1;
 		unsigned int writing:1;
-	    } flags;
-	} ufs;
-	struct {
+	    }
+	    flags;
+	}
+	ufs;
+	struct
+	{
 	    int fd;
-	    struct {
+	    struct
+	    {
 		unsigned int close_request:1;
 		unsigned int reading:1;
 		unsigned int writing:1;
 		unsigned int opening:1;
-	    } flags;
+	    }
+	    flags;
 	    const char *read_buf;
 	    link_list *pending_writes;
 	    link_list *pending_reads;
-	} aufs;
-    } type;
+	}
+	aufs;
+    }
+    type;
 };
 
-struct _request_t {
+struct _request_t
+{
     method_t method;
     protocol_t protocol;
     char login[MAX_LOGIN_SZ];
@@ -1513,20 +1750,23 @@
     time_t lastmod;		/* Used on refreshes */
 };
 
-struct _cachemgr_passwd {
+struct _cachemgr_passwd
+{
     char *passwd;
     wordlist *actions;
     cachemgr_passwd *next;
 };
 
-struct _refresh_t {
+struct _refresh_t
+{
     char *pattern;
     regex_t compiled_pattern;
     time_t min;
     double pct;
     time_t max;
     refresh_t *next;
-    struct {
+    struct
+    {
 	unsigned int icase:1;
 #if HTTP_VIOLATIONS
 	unsigned int override_expire:1;
@@ -1534,10 +1774,12 @@
 	unsigned int reload_into_ims:1;
 	unsigned int ignore_reload:1;
 #endif
-    } flags;
+    }
+    flags;
 };
 
-struct _CommWriteStateData {
+struct _CommWriteStateData
+{
     char *buf;
     size_t size;
     off_t offset;
@@ -1546,7 +1788,8 @@
     FREE *free_func;
 };
 
-struct _ErrorState {
+struct _ErrorState
+{
     err_type type;
     int page_id;
     http_status http_status;
